=== src/lib/CMakeLists.txt ===
add_subdirectory(bit)
add_subdirectory(bitset)
set(SMALL_EMBEDDED ON)
add_subdirectory(small)
add_subdirectory(salad)
add_subdirectory(csv)
add_subdirectory(json)
add_subdirectory(uri)
add_subdirectory(http_parser)
add_subdirectory(core)
add_subdirectory(uuid)
add_subdirectory(coll)
add_subdirectory(crypto)
add_subdirectory(swim)
add_subdirectory(mpstream)
if(ENABLE_BUNDLED_MSGPUCK)
    add_subdirectory(msgpuck EXCLUDE_FROM_ALL)
endif()
