=== test/app-tap/CMakeLists.txt ===
build_module(module_api module_api.c)
