=== debian/changelog ===
tarantool (2.6.0-1.3build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:01:05 +1100

tarantool (2.6.0-1.3build3) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:04:53 +0000

tarantool (2.6.0-1.3build2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 05 Mar 2024 01:23:34 +0000

tarantool (2.6.0-1.3build1) noble; urgency=medium

  * No-change rebuild for ICU soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 11:07:59 +0100

tarantool (2.6.0-1.3) unstable; urgency=medium

  * Non-maintainer upload.

  [ Helmut Grohne ]
  * Install systemd units only once. (Closes: #1054489)

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 25 Nov 2023 14:34:46 +0100

tarantool (2.6.0-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * No source change upload to rebuild with debhelper 13.10.

 -- Michael Biebl <biebl@debian.org>  Sat, 15 Oct 2022 12:51:17 +0200

tarantool (2.6.0-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with glibc 2.34. (Closes: #1001354)
  * Use the system libcurl/libyaml/libzstd instead of the bundled ones.

 -- Adrian Bunk <bunk@debian.org>  Mon, 12 Sep 2022 08:51:23 +0300

tarantool (2.6.0-1) unstable; urgency=medium

  * New upstream version.
  * Fixed debian/rules (drop dh_systemd), closes: #958615
  * To build the package with SysV use INIT_VARIANT=sysv environment tag.
  * Drop exe/dll from source (lintian warnings).
  * Closes other lintian warnings (copyright).

 -- Dmitry E. Oboukhov <unera@debian.org>  Sat, 22 Aug 2020 13:56:57 +0300
