=== debian/watch ===
version=3
http://download.tarantool.org/tarantool/1.7/src/tarantool-(.+).tar.gz
